<?php


namespace Repositories;


use Util\InstanceProvider;

class Paramgeral
{
    public function findParamgeral($fields, $nrOrg)
    {
        $query = "SELECT $fields
                    FROM PARAMGERAL
                   WHERE NRORG = :NRORG";

        $params = array(
            'NRORG' => $nrOrg
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        $result =  $entityManager->getConnection()->fetchAll($query, $params);
        return !empty($result) ? $result[0] : $result;
    }

    public function findPrivacyPolicyPath()
    {
        $query = "SELECT DSARQPOLPRIV
                    FROM PARAMGERAL";

        $entityManager = InstanceProvider::getEntityManager();

        return $entityManager->getConnection()->fetchAll($query);
    }

    public function findPrivacyPolicyPathByAuthentication($nrOrg)
    {
        $query = "SELECT DSARQPOLPRIV
                    FROM PARAMGERAL
                   WHERE NRORG = :NRORG";

        $params = array(
            'NRORG' => $nrOrg
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        $result =  $entityManager->getConnection()->fetchAll($query, $params);
        return !empty($result) ? $result[0] : $result;
    }

    public function updatePrivacyPolicy($dsarqpolpriv, $nrOrg)
    {
        $query = "UPDATE PARAMGERAL
                     SET DSARQPOLPRIV = :DSARQPOLPRIV
                   WHERE NRORG = :NRORG";

        $params = array(
            'NRORG' => $nrOrg,
            'DSARQPOLPRIV' => $dsarqpolpriv
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        return $entityManager->getConnection()->executeQuery($query, $params);
    }

    public function updatePrivacyPolicyClient($dsarqpolprivClie, $nrOrg)
    {
        $query = "UPDATE PARAMGERAL
                     SET DSARQPOLPRIVCLIE = :DSARQPOLPRIVCLIE
                   WHERE NRORG = :NRORG";

        $params = array(
            'NRORG' => $nrOrg,
            'DSARQPOLPRIVCLIE' => $dsarqpolprivClie
        );

        $entityManager = InstanceProvider::getLibConnectionCustom()->updateVpdConnection($nrOrg);
        $entityManager = $entityManager ? $entityManager : InstanceProvider::getEntityManager();

        return $entityManager->getConnection()->executeQuery($query, $params);
    }
}
