/*
  7779_PLATMPS.SQL

  ESTE SCRIPT IR ATUALIZAR A TABELA ITEMRETI, POIS NAS VERSES ANTERIORES AS
  RETIRADAS POR TIPO DE PRATO ERAM GRAVADAS NA TABELA ITEMRETIPRAT, QUE NO EXISTIR.

  31/05/2004 - Alexis Tolentino
*/

DECLARE @V_COUNT             DOUBLE PRECISION;
DECLARE @V_NRSEQUITRETI      VARCHAR(04);
DECLARE @V_CDTIPORETI        VARCHAR(02);
DECLARE @V_TAMANHO           INTEGER;
DECLARE @V_CDNVPRATO         VARCHAR(1);
DECLARE @V_CDPRATO           VARCHAR(10);
DECLARE @V_CDPRATOFIX        VARCHAR(10);
DECLARE @V_CDPRATOPER        VARCHAR(10);
DECLARE @V_CDTIPOPRAT        VARCHAR(2);
DECLARE @V_CDTIPOPRATPER     VARCHAR(2);
DECLARE @V_CDCHAVE           VARCHAR(30);
DECLARE @V_OLD_CDFILIAL      VARCHAR(04);
DECLARE @V_OLD_NRCARDAPIO    VARCHAR(10);
DECLARE @V_OLD_NRRETIRADA    VARCHAR(10);
DECLARE @V_OLD_NRSEQUITRETI  VARCHAR(04);
DECLARE @V_CHAVE_ITEM        VARCHAR(40);
DECLARE @V_NEW_QTRETIRADA    DOUBLE PRECISION;
DECLARE @V_SUM_QTRETIPRAT    DOUBLE PRECISION;
DECLARE @V_NUM_ITENS         INTEGER;

DECLARE @C_PARAMPLA_CDFILIAL          VARCHAR(04);
DECLARE @C_ITEMRETIPRAT_CDFILIAL      VARCHAR(04);
DECLARE @C_ITEMRETIPRAT_NRCARDAPIO    VARCHAR(10);
DECLARE @C_ITEMRETIPRAT_NRRETIRADA    VARCHAR(10);
DECLARE @C_ITEMRETIPRAT_DTRETIRADA    DATETIME;
DECLARE @C_ITEMRETIPRAT_NRREQUEXTRRE  VARCHAR(10);
DECLARE @C_ITEMRETIPRAT_CDFILANCESTQ  VARCHAR(04);
DECLARE @C_ITEMRETIPRAT_NRLANCESTQ    VARCHAR(10);
DECLARE @C_ITEMRETIPRAT_CDPRODUTO     VARCHAR(10);
DECLARE @C_ITEMRETIPRAT_NRSEQUITRETI  VARCHAR(04);
DECLARE @C_ITEMRETIPRAT_CDTIPOPRAT    VARCHAR(02);
DECLARE @C_ITEMRETIPRAT_CDFILAUXPRAT  VARCHAR(04);
DECLARE @C_ITEMRETIPRAT_CDPRATO       VARCHAR(10);
DECLARE @C_ITEMRETIPRAT_QTRETIRADA    DOUBLE PRECISION;
DECLARE @C_ITEMRETIPRAT_QTRETIRADAPR  DOUBLE PRECISION;
DECLARE @C_ITEMRETIPRAT_CDFIITLANEST  VARCHAR(04);
DECLARE @C_ITEMRETIPRAT_NRSEQUITEM    VARCHAR(04);
DECLARE @C_ITEMRETIPRAT_IDINTESIST    VARCHAR(01);

DECLARE @C_ITEMRETI_CDFILIAL      VARCHAR(04);
DECLARE @C_ITEMRETI_NRCARDAPIO    VARCHAR(10);
DECLARE @C_ITEMRETI_NRRETIRADA    VARCHAR(10);
DECLARE @C_ITEMRETI_NRSEQUITRETI  VARCHAR(04);
DECLARE @C_ITEMRETI_CDPRODUTO     VARCHAR(10);
DECLARE @C_ITEMRETI_NRSEQUITEM    VARCHAR(04);
DECLARE @C_ITEMRETI_NRLANCESTQ    VARCHAR(10);
DECLARE @C_ITEMRETI_CDFIITLANEST  VARCHAR(04);

DECLARE @C_DEFAULT_CDFILIAL      VARCHAR(04);
DECLARE @C_DEFAULT_CDTPRCONSFIX  VARCHAR(02);
DECLARE @C_DEFAULT_CDPRACONSFIX  VARCHAR(10);

BEGIN

   SELECT @V_CDNVPRATO = MAX(CDNVPRATO)
   FROM PRATO;

   SELECT @V_CDPRATO = MAX(CDPRATO)
   FROM PRATO
   WHERE (CDNVPRATO = @V_CDNVPRATO);

   SET @V_TAMANHO    = LEN(@V_CDPRATO);
   SET @V_CDPRATOFIX = RIGHT(REPLICATE('F', @V_TAMANHO) + 'F', @V_TAMANHO);
   SET @V_CDPRATOPER = RIGHT(REPLICATE('P', @V_TAMANHO) + 'P', @V_TAMANHO);

   /* INCLUI PRATO E TIPO DE PRATO FIXO */
   SELECT @V_COUNT = COUNT(*)
   FROM PRATO
   WHERE (CDPRATO      = @V_CDPRATOFIX) AND
         (CDFILAUXPRAT = 'P');

   IF (@V_COUNT < 1) BEGIN
      INSERT INTO PRATO(CDFILAUXPRAT, CDPRATO, NMPRATO, CDNVPRATO)
      VALUES('P', @V_CDPRATOFIX, 'Consumo Fixo', @V_CDNVPRATO);
   END
   ELSE BEGIN
      UPDATE PRATO SET NMPRATO = 'Consumo Fixo'
      WHERE CDFILAUXPRAT = 'P' AND CDPRATO = @V_CDPRATOFIX;
   END;

   SELECT @V_COUNT = COUNT(*)
   FROM TIPOPRAT
   WHERE (CDTIPOPRAT = 'FF');

   IF (@V_COUNT < 1) BEGIN
      INSERT INTO TIPOPRAT(CDTIPOPRAT, NMTIPOPRAT)
      VALUES('FF', 'Consumo Fixo');
   END
   ELSE BEGIN
      UPDATE TIPOPRAT SET NMTIPOPRAT = 'Consumo Fixo'
      WHERE CDTIPOPRAT = 'FF';
   END;

   /* INCLUI PRATO E TIPO DE PRATO PER CAPITA */
   SELECT @V_COUNT = COUNT(*)
   FROM PRATO
   WHERE (CDPRATO      = @V_CDPRATOPER) AND
         (CDFILAUXPRAT = 'P');

   IF (@V_COUNT < 1) BEGIN
      INSERT INTO PRATO(CDFILAUXPRAT, CDPRATO, NMPRATO, CDNVPRATO)
      VALUES('P', @V_CDPRATOPER, 'Consumo Percapita', @V_CDNVPRATO);
   END ELSE BEGIN
      UPDATE PRATO SET NMPRATO = 'Consumo Percapita'
      WHERE CDFILAUXPRAT = 'P' AND CDPRATO = @V_CDPRATOPER;
   END;

   SELECT @V_COUNT = COUNT(*)
   FROM TIPOPRAT
   WHERE (CDTIPOPRAT = 'PP');

   IF (@V_COUNT < 1) BEGIN
      INSERT INTO TIPOPRAT(CDTIPOPRAT, NMTIPOPRAT)
      VALUES('PP', 'Cons.Percapita');
   END
   ELSE BEGIN
      UPDATE TIPOPRAT SET NMTIPOPRAT = 'Cons.Percapita'
      WHERE CDTIPOPRAT = 'PP';
   END;


   /*========================================================
   ===== ROTINA PARA GRAVAR PRATO/TIPO DE PRATO DEFAULT =====
   ========================================================*/

   UPDATE PARAMPLANEJA
   SET CDTPRCONSFIX = 'FF';

   UPDATE PARAMPLANEJA
   SET CDFILCONSFIX = 'P',
       CDPRACONSFIX = @V_CDPRATOFIX;

   /* ---- CONSUMO PERCAPITA ----- */

   UPDATE PARAMPLANEJA
   SET CDTPRCONSPER = 'PP';

   UPDATE PARAMPLANEJA
   SET CDFILCONSPER = 'P',
       CDPRACONSPER = @V_CDPRATOPER;

   /* ====================================================
      == ROTINA PARA ATUALIZAR QTRETIRADA DE ACORDO ======
      ================ COM QTTOTLANCTO =================== */

   UPDATE ITEMRETI
   SET QTRETIRADA    = L.QTTOTLANCTO,
        QTEXTRARETI  = L.QTTOTLANCTO,
        QTPREVISRETI = 0.0,
        QTDEVOLVRETI = 0.0
   FROM ITLANCTOEST L
    WHERE
        L.IDTIPOMOVI = '3' AND
        L.CDFILIAL   = ITEMRETI.CDFIITLANEST AND
        L.NRLANCESTQ = ITEMRETI.NRLANCESTQ AND
        L.NRSEQUITEM = ITEMRETI.NRSEQUITEM AND
        L.QTTOTLANCTO <> ITEMRETI.QTRETIRADA;

   /*========================================================
   ===== ROTINA PARA GRAVAR PRATO/TIPO DE PRATO DEFAULT =====
   ========================================================*/

   SET @V_NRSEQUITRETI     = 'X';
   SET @V_CDCHAVE          = 'X';
   SET @V_OLD_CDFILIAL     = 'X';
   SET @V_OLD_NRCARDAPIO   = 'X';
   SET @V_OLD_NRRETIRADA   = 'X';
   SET @V_OLD_NRSEQUITRETI = 'X';

   SET @V_CHAVE_ITEM       = 'X';
   SET @V_NEW_QTRETIRADA   = 0;
   SET @V_SUM_QTRETIPRAT   = 0;
   SET @V_NUM_ITENS        = 0;

   DECLARE C_ITEMRETIPRAT CURSOR FOR
      SELECT
             R.CDFILIAL,   R.NRCARDAPIO,   R.NRRETIRADA,
             R.DTRETIRADA, R.NRREQUEXTRRE, R.NRLANCESTQ,
             I.CDPRODUTO,  P.NRSEQUITRETI, P.CDTIPOPRAT,
             P.CDFILAUXPRAT, P.CDPRATO,    I.QTRETIRADA,
             P.QTRETIRADAPR,
             I.CDFIITLANEST,  I.NRSEQUITEM, I.IDINTESIST
      FROM ITEMRETIPRAT P, ITEMRETI I, RETIRADA R
      WHERE (R.CDFILIAL     = I.CDFILIAL)   AND
            (R.NRCARDAPIO   = I.NRCARDAPIO) AND
            (R.NRRETIRADA   = I.NRRETIRADA) AND
            (R.IDRETIPRAT IS NULL)          AND
            (I.CDFILIAL     = P.CDFILIAL)   AND
            (I.NRCARDAPIO   = P.NRCARDAPIO) AND
            (I.NRRETIRADA   = P.NRRETIRADA) AND
            (I.NRSEQUITRETI = P.NRSEQUITRETI)
      ORDER BY R.CDFILIAL, R.NRCARDAPIO, R.NRRETIRADA, P.NRSEQUITRETI;

   OPEN C_ITEMRETIPRAT;
   FETCH NEXT FROM C_ITEMRETIPRAT INTO @C_ITEMRETIPRAT_CDFILIAL,   @C_ITEMRETIPRAT_NRCARDAPIO,   @C_ITEMRETIPRAT_NRRETIRADA,
                                       @C_ITEMRETIPRAT_DTRETIRADA, @C_ITEMRETIPRAT_NRREQUEXTRRE, @C_ITEMRETIPRAT_NRLANCESTQ,
                                       @C_ITEMRETIPRAT_CDPRODUTO,  @C_ITEMRETIPRAT_NRSEQUITRETI, @C_ITEMRETIPRAT_CDTIPOPRAT,
                                       @C_ITEMRETIPRAT_CDFILAUXPRAT, @C_ITEMRETIPRAT_CDPRATO,    @C_ITEMRETIPRAT_QTRETIRADA,
                                       @C_ITEMRETIPRAT_QTRETIRADAPR,
                                       @C_ITEMRETIPRAT_CDFIITLANEST, @C_ITEMRETIPRAT_NRSEQUITEM,  @C_ITEMRETIPRAT_IDINTESIST;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF (@V_CHAVE_ITEM <> @C_ITEMRETIPRAT_CDFILIAL+@C_ITEMRETIPRAT_NRCARDAPIO+@C_ITEMRETIPRAT_NRRETIRADA+@C_ITEMRETIPRAT_NRSEQUITRETI) BEGIN

         SELECT
           @V_CHAVE_ITEM = CDFILIAL+NRCARDAPIO+NRRETIRADA+NRSEQUITRETI,
           @V_NUM_ITENS = COUNT(*),
           @V_SUM_QTRETIPRAT = SUM(QTRETIRADAPR)
         FROM
            ITEMRETIPRAT
         WHERE
            CDFILIAL    = @C_ITEMRETIPRAT_CDFILIAL   AND
            NRCARDAPIO  = @C_ITEMRETIPRAT_NRCARDAPIO AND
            NRRETIRADA  = @C_ITEMRETIPRAT_NRRETIRADA AND
            NRSEQUITRETI = @C_ITEMRETIPRAT_NRSEQUITRETI
         GROUP BY
            CDFILIAL+NRCARDAPIO+NRRETIRADA+NRSEQUITRETI;
      END;

      IF (@V_SUM_QTRETIPRAT <> @C_ITEMRETIPRAT_QTRETIRADA) BEGIN
         IF (@V_SUM_QTRETIPRAT = 0) BEGIN
            /* SE A SOMA DAS QTDES POR PRATO FOR 0,
               A QUANTIDADE  RATEADA PELO NMERO DE ITENS */
            SET @V_NEW_QTRETIRADA = ROUND(@C_ITEMRETIPRAT_QTRETIRADA / @V_NUM_ITENS, 5);
         END
         ELSE BEGIN
            /* SE A SOMA FOR DIFERENTE DE ZERO,
               A QUANTIDADE A SER INSERIDA  CALCULADA
               PELO VALOR PERCENTUAL
               DA QTDE. POR PRATO EM RELAO  SOMA. */
            SET @V_NEW_QTRETIRADA = ROUND((@C_ITEMRETIPRAT_QTRETIRADAPR / @V_SUM_QTRETIPRAT) * @C_ITEMRETIPRAT_QTRETIRADA, 5);
         END;
      END
      ELSE BEGIN
         SET @V_NEW_QTRETIRADA = @C_ITEMRETIPRAT_QTRETIRADAPR;
      END;

      IF (@V_CDCHAVE <> @C_ITEMRETIPRAT_CDFILIAL+@C_ITEMRETIPRAT_NRCARDAPIO+@C_ITEMRETIPRAT_NRRETIRADA) BEGIN

         SELECT @V_NRSEQUITRETI = MAX(NRSEQUITRETI)
         FROM ITEMRETI
         WHERE (CDFILIAL   = @C_ITEMRETIPRAT_CDFILIAL)   AND
               (NRCARDAPIO = @C_ITEMRETIPRAT_NRCARDAPIO) AND
               (NRRETIRADA = @C_ITEMRETIPRAT_NRRETIRADA);

         UPDATE RETIRADA
         SET IDRETIPRAT = 'S'
         WHERE (CDFILIAL   = @C_ITEMRETIPRAT_CDFILIAL)   AND
               (NRCARDAPIO = @C_ITEMRETIPRAT_NRCARDAPIO) AND
               (NRRETIRADA = @C_ITEMRETIPRAT_NRRETIRADA);

      END;

      IF (@V_OLD_NRSEQUITRETI <> '') AND (@V_OLD_NRSEQUITRETI <> @C_ITEMRETIPRAT_NRSEQUITRETI) BEGIN

         DELETE FROM ITEMRETI  /* APAGA O ITEMRETI QUE TEVE SEUS FILHOS ITEMRETIPRAT EXCLUIDOS */
         WHERE (CDFILIAL     = @V_OLD_CDFILIAL    )  AND
               (NRCARDAPIO   = @V_OLD_NRCARDAPIO  )  AND
               (NRRETIRADA   = @V_OLD_NRRETIRADA  )  AND
               (NRSEQUITRETI = @V_OLD_NRSEQUITRETI);

      END;

      SET @V_NRSEQUITRETI = CONVERT(VARCHAR, CONVERT(DOUBLE PRECISION, @V_NRSEQUITRETI) + 1);

      SELECT @V_CDTIPORETI = MAX(L.CDTIPORETI)
      FROM ITLANCTOEST L
      WHERE (L.NRLANCESTQ = @C_ITEMRETIPRAT_NRLANCESTQ)  AND
            (L.NRSEQUITEM = @C_ITEMRETIPRAT_NRSEQUITEM)  AND
            (L.CDPRODUTO  = @C_ITEMRETIPRAT_CDPRODUTO)   AND
            (L.CDFILIAL   = @C_ITEMRETIPRAT_CDFIITLANEST);

      INSERT INTO ITEMRETI(CDFILIAL,     NRCARDAPIO,   NRRETIRADA,     /*INCLUI O ITEMRETIPRAT NA ITEMRETI */
                           NRSEQUITRETI, CDPRODUTO,    QTPREVISRETI,
                           QTEXTRARETI,  QTDEVOLVRETI, QTRETIRADA,
                           CDFIITLANEST, NRLANCESTQ,   NRSEQUITEM,
                           IDINTESIST,   CDTIPOPRAT,
                           CDFILAUXPRAT, CDPRATO, CDTIPORETI)
      VALUES (@C_ITEMRETIPRAT_CDFILIAL,      @C_ITEMRETIPRAT_NRCARDAPIO,   @C_ITEMRETIPRAT_NRRETIRADA,
              RIGHT(REPLICATE('0', 4) + @V_NRSEQUITRETI, 4),
              @C_ITEMRETIPRAT_CDPRODUTO,     @V_NEW_QTRETIRADA,
              0.0, 0.0, @V_NEW_QTRETIRADA,
              @C_ITEMRETIPRAT_CDFIITLANEST,  @C_ITEMRETIPRAT_NRLANCESTQ,   @C_ITEMRETIPRAT_NRSEQUITEM,
              @C_ITEMRETIPRAT_IDINTESIST,    @C_ITEMRETIPRAT_CDTIPOPRAT,
              @C_ITEMRETIPRAT_CDFILAUXPRAT,  @C_ITEMRETIPRAT_CDPRATO, @V_CDTIPORETI);

      SET @V_CDCHAVE = @C_ITEMRETIPRAT_CDFILIAL+@C_ITEMRETIPRAT_NRCARDAPIO+@C_ITEMRETIPRAT_NRRETIRADA;

      SET @V_OLD_CDFILIAL     = @C_ITEMRETIPRAT_CDFILIAL;
      SET @V_OLD_NRCARDAPIO   = @C_ITEMRETIPRAT_NRCARDAPIO;
      SET @V_OLD_NRRETIRADA   = @C_ITEMRETIPRAT_NRRETIRADA;
      SET @V_OLD_NRSEQUITRETI = @C_ITEMRETIPRAT_NRSEQUITRETI;

      FETCH NEXT FROM C_ITEMRETIPRAT INTO @C_ITEMRETIPRAT_CDFILIAL,   @C_ITEMRETIPRAT_NRCARDAPIO,   @C_ITEMRETIPRAT_NRRETIRADA,
                                          @C_ITEMRETIPRAT_DTRETIRADA, @C_ITEMRETIPRAT_NRREQUEXTRRE, @C_ITEMRETIPRAT_NRLANCESTQ,
                                          @C_ITEMRETIPRAT_CDPRODUTO,  @C_ITEMRETIPRAT_NRSEQUITRETI, @C_ITEMRETIPRAT_CDTIPOPRAT,
                                          @C_ITEMRETIPRAT_CDFILAUXPRAT, @C_ITEMRETIPRAT_CDPRATO,    @C_ITEMRETIPRAT_QTRETIRADA,
                                          @C_ITEMRETIPRAT_QTRETIRADAPR,
                                          @C_ITEMRETIPRAT_CDFIITLANEST, @C_ITEMRETIPRAT_NRSEQUITEM,  @C_ITEMRETIPRAT_IDINTESIST;

   END;
   CLOSE C_ITEMRETIPRAT;
   DEALLOCATE C_ITEMRETIPRAT;

   IF (@V_OLD_NRSEQUITRETI <> 'X') BEGIN  /* APAGA O ULTIMO ITEMRETI Q ESTAVA NO LOOP */
      DELETE FROM ITEMRETI
      WHERE (CDFILIAL     = @V_OLD_CDFILIAL    )  AND
            (NRCARDAPIO   = @V_OLD_NRCARDAPIO  )  AND
            (NRRETIRADA   = @V_OLD_NRRETIRADA  )  AND
            (NRSEQUITRETI = @V_OLD_NRSEQUITRETI);
   END;

   SET @V_CDCHAVE = 'X';

   DECLARE C_ITEMRETI CURSOR FOR
      SELECT R.CDFILIAL, R.NRCARDAPIO, R.NRRETIRADA,
             I.NRSEQUITRETI, I.CDPRODUTO,
             I.NRSEQUITEM, I.NRLANCESTQ, I.CDFIITLANEST
      FROM ITEMRETI I, RETIRADA R
      WHERE (R.IDRETIPRAT IS NULL)          AND
            (I.CDFILIAL     = R.CDFILIAL)   AND
            (I.NRCARDAPIO   = R.NRCARDAPIO) AND
            (I.NRRETIRADA   = R.NRRETIRADA)
      ORDER BY R.CDFILIAL, R.NRCARDAPIO, R.NRRETIRADA, I.NRSEQUITRETI;
   OPEN C_ITEMRETI;
   FETCH NEXT FROM C_ITEMRETI INTO @C_ITEMRETI_CDFILIAL,     @C_ITEMRETI_NRCARDAPIO, @C_ITEMRETI_NRRETIRADA,
                                   @C_ITEMRETI_NRSEQUITRETI, @C_ITEMRETI_CDPRODUTO,
                                   @C_ITEMRETI_NRSEQUITEM,   @C_ITEMRETI_NRLANCESTQ, @C_ITEMRETI_CDFIITLANEST;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_CDTIPORETI = MAX(L.CDTIPORETI)
      FROM ITLANCTOEST L
      WHERE (L.NRLANCESTQ = @C_ITEMRETI_NRLANCESTQ)  AND
            (L.NRSEQUITEM = @C_ITEMRETI_NRSEQUITEM)  AND
            (L.CDPRODUTO  = @C_ITEMRETI_CDPRODUTO)   AND
            (L.CDFILIAL   = @C_ITEMRETI_CDFIITLANEST);

      UPDATE ITEMRETI
      SET CDTIPORETI = @V_CDTIPORETI
      WHERE (CDFILIAL     = @C_ITEMRETI_CDFILIAL)     AND
            (NRCARDAPIO   = @C_ITEMRETI_NRCARDAPIO)   AND
            (NRRETIRADA   = @C_ITEMRETI_NRRETIRADA)   AND
            (NRSEQUITRETI = @C_ITEMRETI_NRSEQUITRETI) AND
            (CDPRODUTO    = @C_ITEMRETI_CDPRODUTO)    AND
            (CDTIPORETI IS NULL);

      IF (@V_CDCHAVE <> @C_ITEMRETI_CDFILIAL + @C_ITEMRETI_NRCARDAPIO + @C_ITEMRETI_NRRETIRADA) BEGIN
         UPDATE RETIRADA
         SET IDRETIPRAT = 'N'
         WHERE (CDFILIAL   = @C_ITEMRETI_CDFILIAL)   AND
               (NRCARDAPIO = @C_ITEMRETI_NRCARDAPIO) AND
               (NRRETIRADA = @C_ITEMRETI_NRRETIRADA);
      END;

      SET @V_CDCHAVE = @C_ITEMRETI_CDFILIAL + @C_ITEMRETI_NRCARDAPIO + @C_ITEMRETI_NRRETIRADA;

      FETCH NEXT FROM C_ITEMRETI INTO @C_ITEMRETI_CDFILIAL,     @C_ITEMRETI_NRCARDAPIO, @C_ITEMRETI_NRRETIRADA,
                                      @C_ITEMRETI_NRSEQUITRETI, @C_ITEMRETI_CDPRODUTO,
                                      @C_ITEMRETI_NRSEQUITEM,   @C_ITEMRETI_NRLANCESTQ, @C_ITEMRETI_CDFIITLANEST;
   END;
   CLOSE C_ITEMRETI;
   DEALLOCATE C_ITEMRETI;

   DECLARE C_DEFAULT CURSOR FOR
      SELECT CDFILIAL, CDTPRCONSFIX, CDPRACONSFIX
      FROM PARAMPLANEJA;
   OPEN C_DEFAULT;
   FETCH NEXT FROM C_DEFAULT INTO @C_DEFAULT_CDFILIAL, @C_DEFAULT_CDTPRCONSFIX, @C_DEFAULT_CDPRACONSFIX;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      UPDATE ITEMRETI
      SET CDPRATO      = @C_DEFAULT_CDPRACONSFIX,
          CDFILAUXPRAT = 'P',
          CDTIPOPRAT   = @C_DEFAULT_CDTPRCONSFIX
      WHERE (CDFILIAL = @C_DEFAULT_CDFILIAL) AND
            ('S' = (SELECT IDRETIPRAT
                    FROM RETIRADA R
                    WHERE (R.CDFILIAL   = ITEMRETI.CDFILIAL)     AND
                          (R.NRCARDAPIO = ITEMRETI.NRCARDAPIO)   AND
                          (R.NRRETIRADA = ITEMRETI.NRRETIRADA))) AND
            (CDPRATO IS NULL);

      FETCH NEXT FROM C_DEFAULT INTO @C_DEFAULT_CDFILIAL, @C_DEFAULT_CDTPRCONSFIX, @C_DEFAULT_CDPRACONSFIX;
   END;
   CLOSE C_DEFAULT;
   DEALLOCATE C_DEFAULT;

END;
GO

